<template>
  <div>
    <template v-if="isOnlyView">
      <ObInput
        :label="`Г${contractorTypeWordRoot}ь`"
        :value="selectedContractor && selectedContractor.title"
        :readonly="true"
      />
    </template>
    <template v-else>
      <ObSelect
        ref="select"
        :value="value"
        :remote-opt="generateContractorsList"
        :remote-trigger="pointType + remoteTrigger"
        :label="`Г${contractorTypeWordRoot}ь`"
        placeholder="Выберите из списка"
        :is-standart="true"
        :itemBottom="{
          icon: 'plus',
          title: `Добавить г${contractorTypeWordRoot}я`,
        }"
        class="mt30 mb20"
        data-qa="contractorSelect"
        @bottom="openAddModal"
        @selected="onSelectContractor"
      >
        <template v-slot="{ items }">
          <div v-if="items">
            <div
              class="contractor"
              v-for="(item, index) in items.filter((i) => i.location === 'near')"
              :key="item.uuid"
              :data-qa="'contractorSelect_' + index"
            >
              <p v-if="index === 0 && items.filter((i) => i.location === 'other').length">
                Неподалёку от г. {{ computedAddressTitle }}
              </p>
              <div
                class="contractor__item"
                @click="onClickContractor(item)"
              >
                {{ item.title }}
                <span v-if="item.inn">{{ item.inn }}</span>
              </div>
            </div>
            <div
              class="contractor"
              v-for="(item, index) in items.filter((i) => i.location === 'other')"
              :key="item.uuid"
              :data-qa="'contractorSelect_' + index"
            >
              <p v-if="index === 0 && items.filter((i) => i.location === 'near').length">
                Другие грузоотправители
              </p>
              <div
                class="contractor__item"
                @click="onClickContractor(item)"
              >
                {{ item.title }}
                <span v-if="item.inn">{{ item.inn }}</span>
              </div>
            </div>
          </div>
        </template>
      </ObSelect>
    </template>
    <div class="block-inn">
      <template v-if="selectedContractorInn">
        <span>ИНН</span>
        <span>{{ selectedContractorInn }}</span>
      </template>
    </div>
    <NewConsigneeOrConsignor
      ref="addContractorModal"
      :cargo-owner-uuid="ownerUuid"
      :is-consignee="!isConsignor"
      :is-consignor="isConsignor"
      @submitted="onCreateContractor"
    />
  </div>
</template>

<script>
import api from "@/api"
import NewConsigneeOrConsignor from '@/components/Order/modal/NewConsigneeOrConsignor'
import ObSelect from 'common-components/src/obComponents/obSelect'
import ObInput from 'common-components/src/obComponents/obInput'

export default {
  name: 'OrderConsignorOrConsigneeSelect',
  components: {
    ObSelect,
    ObInput,
    NewConsigneeOrConsignor
  },
  props: {
    value: {
      type: String,
      default: null
    },
    ownerUuid: {
      type: String,
      required: true
    },
    addressTitle: {
      type: String,
      default: () => ''
    },
    address: {
      type: Object,
      default: () => {
        return { coordinates: {} }
      }
    },
    pointType: {
      type: String,
      default: 'CONSIGNOR'
    },
    remoteTrigger: {
      type: [String, Number, Object, Boolean],
      default: true
    },
    isOnlyView: {
      type: Boolean,
      default: false
    }
  },
  data () {
    return {
      selectedContractor: null
    }
  },
  async mounted () {
    if (this.isOnlyView && this.value) {
      this.selectedContractor = await api.orderProcess.getConsignorsConsigneesInfo({ uuid: this.value, ownerUuid: this.ownerUuid })
    }
  },
  watch: {
    async value (value) {
      if (!value) {
        this.selectedContractor = null
      } else {
        if (this.isOnlyView) {
          this.selectedContractor = await api.orderProcess.getConsignorsConsigneesInfo({ uuid: this.value, ownerUuid: this.ownerUuid })
        }
      }
    },
    address (value) {
      if (value) {
        this.$refs.select.loadData({ init: true })
      }
    }
  },
  computed: {
    isConsignor () {
      return this.pointType === 'CONSIGNOR'
    },
    contractorTypeWordRoot () {
      return this.isConsignor
        ? 'рузоотправител'
        : 'рузополучател'
    },
    selectedContractorInn () {
      return this.selectedContractor && this.selectedContractor.inn
    },
    computedAddressTitle () {
      return this.addressTitle || this.address?.addressTitle || this.address?.title
    }
  },
  methods: {
    async generateContractorsList () {
      let list = []
      const payloadForDistance = {
        ownerUuid: this.ownerUuid,
        coordinates: {
          lat: this.address?.coordinates?.lat || this.address?.coordinates?.[0],
          lon: this.address?.coordinates?.lon || this.address?.coordinates?.[1]
        },
        type: this.pointType
      }
      const payloadForType = {
        ownerUuid: this.ownerUuid,
        type: this.pointType
      }

      try {
        try {
          const distanceList = await api.orderProcess.getConsignorsConsigneesList(payloadForDistance)
          payloadForType.list = distanceList.map((item) => item.uuid)

          list = list.concat(distanceList.map((item) => ({ ...item, location: 'near' })))
        } catch (error) {
          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка загрузки данных',
          })
        }

        const otherList = await api.orderProcess.getConsignorsConsigneesListExcludedUuids(payloadForType)
        list = list.concat(otherList.map((item) => ({ ...item, location: 'other' })))
      } catch (error) {
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных',
        })
      }

      return list
    },
    onClickContractor (item) {
      this.$refs.select.setItem(item)
    },
    openAddModal () {
      this.$refs.addContractorModal.open()
    },
    onCreateContractor (data) {
      this.selectedContractor = data
      this.$refs.select.loadData({ init: true })
      this.$nextTick(() => {
        this.$emit('on-select-contractor', { ...data, uuid: data.contractorUuid })
      })
    },
    onSelectContractor (item) {
      this.selectedContractor = item
      this.$emit('on-select-contractor', item)
    },
  }
}
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";

.contractor {
  @include font-mixin(15px, 16px, 400, $color-text-base);

  p {
    padding: 12px 22px 5px 22px;
    @include font-mixin(12px, 16px, 400, $color-grey-label);
  }

  .contractor__item {
    display: flex;
    flex-direction: column;
    padding: 12px 22px;
    cursor: pointer;

    &:hover {
      background-color: $light-lavender;
    }

    span {
      padding-top: 3px;
      @include font-mixin(12px, 16px, 400, $color-grey-label);
    }
  }
}

.contractor + .contractor p {
  margin-top: 5px;
}

.block-inn {
  margin-bottom: 10px;
  margin-top: 10px;
  span {
    @include font-mixin(14px, 18px, 400, $color-text-base);
    &:first-child {
      margin-right: 7px;
      color: $color-grey-label;
    }
  }
}
</style>